/* ***********************************************************
 * This file was automatically generated on 2012-12-20.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

/**
 * Device for receiving GPS position
 */
public class BrickletGPS extends Device {
	private final static byte FUNCTION_GET_COORDINATES = (byte)1;
	private final static byte FUNCTION_GET_STATUS = (byte)2;
	private final static byte FUNCTION_GET_ALTITUDE = (byte)3;
	private final static byte FUNCTION_GET_MOTION = (byte)4;
	private final static byte FUNCTION_GET_DATE_TIME = (byte)5;
	private final static byte FUNCTION_RESTART = (byte)6;
	private final static byte FUNCTION_SET_COORDINATES_CALLBACK_PERIOD = (byte)7;
	private final static byte FUNCTION_GET_COORDINATES_CALLBACK_PERIOD = (byte)8;
	private final static byte FUNCTION_SET_STATUS_CALLBACK_PERIOD = (byte)9;
	private final static byte FUNCTION_GET_STATUS_CALLBACK_PERIOD = (byte)10;
	private final static byte FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD = (byte)11;
	private final static byte FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD = (byte)12;
	private final static byte FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD = (byte)13;
	private final static byte FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD = (byte)14;
	private final static byte FUNCTION_SET_MOTION_CALLBACK_PERIOD = (byte)15;
	private final static byte FUNCTION_GET_MOTION_CALLBACK_PERIOD = (byte)16;
	private final static byte CALLBACK_COORDINATES = (byte)17;
	private final static byte CALLBACK_STATUS = (byte)18;
	private final static byte CALLBACK_ALTITUDE = (byte)19;
	private final static byte CALLBACK_MOTION = (byte)20;
	private final static byte CALLBACK_DATE_TIME = (byte)21;

	public class Coordinates {
		public long latitude;
		public char ns;
		public long longitude;
		public char ew;
		public int pdop;
		public int hdop;
		public int vdop;
		public int epe;

		public String toString() {
			return "[" + "latitude = " + latitude + ", " + "ns = " + ns + ", " + "longitude = " + longitude + ", " + "ew = " + ew + ", " + "pdop = " + pdop + ", " + "hdop = " + hdop + ", " + "vdop = " + vdop + ", " + "epe = " + epe + "]";
		}
	}

	public class Status {
		public short fix;
		public short satellitesView;
		public short satellitesUsed;

		public String toString() {
			return "[" + "fix = " + fix + ", " + "satellitesView = " + satellitesView + ", " + "satellitesUsed = " + satellitesUsed + "]";
		}
	}

	public class Altitude {
		public long altitude;
		public long geoidalSeparation;

		public String toString() {
			return "[" + "altitude = " + altitude + ", " + "geoidalSeparation = " + geoidalSeparation + "]";
		}
	}

	public class Motion {
		public long course;
		public long speed;

		public String toString() {
			return "[" + "course = " + course + ", " + "speed = " + speed + "]";
		}
	}

	public class DateTime {
		public long date;
		public long time;

		public String toString() {
			return "[" + "date = " + date + ", " + "time = " + time + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link com.tinkerforge.BrickletGPS.setCoordinatesCallbackPeriod}. The parameters are the same
	 * as for {@link com.tinkerforge.BrickletGPS.getCoordinates}.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.CoordinatesListener} is only triggered if the coordinates changed since the
	 * last triggering.
	 */
	public interface CoordinatesListener {
		public void coordinates(long latitude, char ns, long longitude, char ew, int pdop, int hdop, int vdop, int epe);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link com.tinkerforge.BrickletGPS.setStatusCallbackPeriod}. The parameters are the same
	 * as for {@link com.tinkerforge.BrickletGPS.getStatus}.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.StatusListener} is only triggered if the status changed since the
	 * last triggering.
	 */
	public interface StatusListener {
		public void status(short fix, short satellitesView, short satellitesUsed);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link com.tinkerforge.BrickletGPS.setAltitudeCallbackPeriod}. The parameters are the same
	 * as for {@link com.tinkerforge.BrickletGPS.getAltitude}.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.AltitudeListener} is only triggered if the altitude changed since the
	 * last triggering.
	 */
	public interface AltitudeListener {
		public void altitude(long altitude, long geoidalSeparation);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link com.tinkerforge.BrickletGPS.setMotionCallbackPeriod}. The parameters are the same
	 * as for {@link com.tinkerforge.BrickletGPS.getMotion}.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.MotionListener} is only triggered if the motion changed since the
	 * last triggering.
	 */
	public interface MotionListener {
		public void motion(long course, long speed);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link com.tinkerforge.BrickletGPS.setDateTimeCallbackPeriod}. The parameters are the same
	 * as for {@link com.tinkerforge.BrickletGPS.getDateTime}.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.DateTimeListener} is only triggered if the date or time changed since the
	 * last triggering.
	 */
	public interface DateTimeListener {
		public void dateTime(long date, long time);
	}

	/**
	 * Creates an object with the unique device ID \c uid. This object can
	 * then be added to the IP connection.
	 */
	public BrickletGPS(String uid) {
		super(uid);

		expectedName = "GPS Bricklet";

		bindingVersion[0] = 1;
		bindingVersion[1] = 0;
		bindingVersion[2] = 0;

		callbacks[CALLBACK_COORDINATES] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long latitude = IPConnection.unsignedInt(bb.getInt());
				char ns = (char)(bb.get());
				long longitude = IPConnection.unsignedInt(bb.getInt());
				char ew = (char)(bb.get());
				int pdop = IPConnection.unsignedShort(bb.getShort());
				int hdop = IPConnection.unsignedShort(bb.getShort());
				int vdop = IPConnection.unsignedShort(bb.getShort());
				int epe = IPConnection.unsignedShort(bb.getShort());

				((CoordinatesListener)listenerObjects[CALLBACK_COORDINATES]).coordinates(latitude, ns, longitude, ew, pdop, hdop, vdop, epe);
			}
		};

		callbacks[CALLBACK_STATUS] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short fix = IPConnection.unsignedByte(bb.get());
				short satellitesView = IPConnection.unsignedByte(bb.get());
				short satellitesUsed = IPConnection.unsignedByte(bb.get());

				((StatusListener)listenerObjects[CALLBACK_STATUS]).status(fix, satellitesView, satellitesUsed);
			}
		};

		callbacks[CALLBACK_ALTITUDE] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long altitude = IPConnection.unsignedInt(bb.getInt());
				long geoidalSeparation = IPConnection.unsignedInt(bb.getInt());

				((AltitudeListener)listenerObjects[CALLBACK_ALTITUDE]).altitude(altitude, geoidalSeparation);
			}
		};

		callbacks[CALLBACK_MOTION] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long course = IPConnection.unsignedInt(bb.getInt());
				long speed = IPConnection.unsignedInt(bb.getInt());

				((MotionListener)listenerObjects[CALLBACK_MOTION]).motion(course, speed);
			}
		};

		callbacks[CALLBACK_DATE_TIME] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long date = IPConnection.unsignedInt(bb.getInt());
				long time = IPConnection.unsignedInt(bb.getInt());

				((DateTimeListener)listenerObjects[CALLBACK_DATE_TIME]).dateTime(date, time);
			}
		};
	}

	/**
	 * Returns the GPS coordinates. Latitude and longitude are given in the
	 * DD.dddddd° format. The parameter ns and ew are the cardinal directions for
	 * latitude and logitude. Possible values for ns and ew are 'N', 'S', 'E'
	 * and 'W' (north, south, east and west).
	 * 
	 * PDOP, HDOP and VDOP are the dilution of precision (DOP) values. They specify
	 * the additional multiplicative effect of GPS satellite geometry on GPS 
	 * precision. See 
	 * `here <http://en.wikipedia.org/wiki/Dilution_of_precision_(GPS)>`__
	 * for more information. The values are give in hundreths.
	 * 
	 * EPE is the "Estimated Position Error". The EPE is given in cm. This is not the
	 * absolute maximum error, it is the error with a specific confidence. See
	 * `here <http://www.nps.gov/gis/gps/WhatisEPE.html>`__ for more information.
	 */
	public Coordinates getCoordinates() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_COORDINATES, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_COORDINATES);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Coordinates obj = new Coordinates();
		obj.latitude = IPConnection.unsignedInt(bb.getInt());
		obj.ns = (char)(bb.get());
		obj.longitude = IPConnection.unsignedInt(bb.getInt());
		obj.ew = (char)(bb.get());
		obj.pdop = IPConnection.unsignedShort(bb.getShort());
		obj.hdop = IPConnection.unsignedShort(bb.getShort());
		obj.vdop = IPConnection.unsignedShort(bb.getShort());
		obj.epe = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the current fix status, the number of satellites that are in view and
	 * the number of satellites that are currently used.
	 * 
	 * Possible fix status values can be:
	 * 
	 * \verbatim
	 *  "Value", "Description"
	 * 
	 *  "1", "No Fix"
	 *  "2", "2D Fix"
	 *  "3", "3D Fix"
	 * \endverbatim
	 */
	public Status getStatus() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_STATUS, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_STATUS);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Status obj = new Status();
		obj.fix = IPConnection.unsignedByte(bb.get());
		obj.satellitesView = IPConnection.unsignedByte(bb.get());
		obj.satellitesUsed = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the current altitude and corresponding geoidal separation.
	 * 
	 * Both values are given in cm.
	 */
	public Altitude getAltitude() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_ALTITUDE, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_ALTITUDE);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Altitude obj = new Altitude();
		obj.altitude = IPConnection.unsignedInt(bb.getInt());
		obj.geoidalSeparation = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the current course and speed. Course is given in hundreths degree
	 * and speed is given in hundreths km/h.
	 * 
	 * Please note that this only returns useful values if an actual movement
	 * is present.
	 */
	public Motion getMotion() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_MOTION, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_MOTION);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Motion obj = new Motion();
		obj.course = IPConnection.unsignedInt(bb.getInt());
		obj.speed = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the current date and time. The date is
	 * given in the format ddmmyy and the time is given
	 * in the format hhmmss.sss
	 */
	public DateTime getDateTime() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_DATE_TIME, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_DATE_TIME);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DateTime obj = new DateTime();
		obj.date = IPConnection.unsignedInt(bb.getInt());
		obj.time = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Restarts the GPS Bricklet, the following restart types are available:
	 * 
	 * \verbatim
	 *  "Value", "Description"
	 * 
	 *  "0", "Hot start (use all available data in the NV store)"
	 *  "1", "Warm start (don't use ephemeris at restart)"
	 *  "2", "Cold start (don't use time, position, almanacs and ephemeris at restart)"
	 *  "3", "Factory reset (clear all system/user configurations at restart)"
	 * \endverbatim
	 */
	public void restart(short restartType)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_RESTART, (short)5);
		bb.put((byte)restartType);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Sets the period in ms with which the {@link com.tinkerforge.BrickletGPS.CoordinatesListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.CoordinatesListener} is only triggered if the coordinates changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setCoordinatesCallbackPeriod(long period)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_COORDINATES_CALLBACK_PERIOD, (short)8);
		bb.putInt((int)period);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the period as set by {@link com.tinkerforge.BrickletGPS.setCoordinatesCallbackPeriod}.
	 */
	public long getCoordinatesCallbackPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_COORDINATES_CALLBACK_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_COORDINATES_CALLBACK_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link com.tinkerforge.BrickletGPS.StatusListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.StatusListener} is only triggered if the status changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setStatusCallbackPeriod(long period)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_STATUS_CALLBACK_PERIOD, (short)8);
		bb.putInt((int)period);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the period as set by {@link com.tinkerforge.BrickletGPS.setStatusCallbackPeriod}.
	 */
	public long getStatusCallbackPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_STATUS_CALLBACK_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_STATUS_CALLBACK_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link com.tinkerforge.BrickletGPS.AltitudeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.AltitudeListener} is only triggered if the altitude changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setAltitudeCallbackPeriod(long period)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD, (short)8);
		bb.putInt((int)period);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the period as set by {@link com.tinkerforge.BrickletGPS.setAltitudeCallbackPeriod}.
	 */
	public long getAltitudeCallbackPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link com.tinkerforge.BrickletGPS.DateTimeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.DateTimeListener} is only triggered if the date or time changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setDateTimeCallbackPeriod(long period)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD, (short)8);
		bb.putInt((int)period);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the period as set by {@link com.tinkerforge.BrickletGPS.setDateTimeCallbackPeriod}.
	 */
	public long getDateTimeCallbackPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link com.tinkerforge.BrickletGPS.MotionListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * {@link com.tinkerforge.BrickletGPS.MotionListener} is only triggered if the motion changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setMotionCallbackPeriod(long period)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_MOTION_CALLBACK_PERIOD, (short)8);
		bb.putInt((int)period);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the period as set by {@link com.tinkerforge.BrickletGPS.setMotionCallbackPeriod}.
	 */
	public long getMotionCallbackPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_MOTION_CALLBACK_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_MOTION_CALLBACK_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Registers a listener object.
	 */
	public void addListener(Object o) {
		if(o instanceof CoordinatesListener) {
			listenerObjects[CALLBACK_COORDINATES] = o;
		} else if(o instanceof StatusListener) {
			listenerObjects[CALLBACK_STATUS] = o;
		} else if(o instanceof AltitudeListener) {
			listenerObjects[CALLBACK_ALTITUDE] = o;
		} else if(o instanceof MotionListener) {
			listenerObjects[CALLBACK_MOTION] = o;
		} else if(o instanceof DateTimeListener) {
			listenerObjects[CALLBACK_DATE_TIME] = o;
		}
	}
}