/* ***********************************************************
 * This file was automatically generated on 2012-12-20.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

/**
 * Device for high precision sensing of voltage and current
 */
public class BrickletVoltageCurrent extends Device {
	private final static byte FUNCTION_GET_CURRENT = (byte)1;
	private final static byte FUNCTION_GET_VOLTAGE = (byte)2;
	private final static byte FUNCTION_GET_POWER = (byte)3;
	private final static byte FUNCTION_SET_CONFIGURATION = (byte)4;
	private final static byte FUNCTION_GET_CONFIGURATION = (byte)5;
	private final static byte FUNCTION_SET_CALIBRATION = (byte)6;
	private final static byte FUNCTION_GET_CALIBRATION = (byte)7;
	private final static byte FUNCTION_SET_CURRENT_CALLBACK_PERIOD = (byte)8;
	private final static byte FUNCTION_GET_CURRENT_CALLBACK_PERIOD = (byte)9;
	private final static byte FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = (byte)10;
	private final static byte FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = (byte)11;
	private final static byte FUNCTION_SET_POWER_CALLBACK_PERIOD = (byte)12;
	private final static byte FUNCTION_GET_POWER_CALLBACK_PERIOD = (byte)13;
	private final static byte FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = (byte)14;
	private final static byte FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = (byte)15;
	private final static byte FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = (byte)16;
	private final static byte FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = (byte)17;
	private final static byte FUNCTION_SET_POWER_CALLBACK_THRESHOLD = (byte)18;
	private final static byte FUNCTION_GET_POWER_CALLBACK_THRESHOLD = (byte)19;
	private final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)20;
	private final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)21;
	private final static byte CALLBACK_CURRENT = (byte)22;
	private final static byte CALLBACK_VOLTAGE = (byte)23;
	private final static byte CALLBACK_POWER = (byte)24;
	private final static byte CALLBACK_CURRENT_REACHED = (byte)25;
	private final static byte CALLBACK_VOLTAGE_REACHED = (byte)26;
	private final static byte CALLBACK_POWER_REACHED = (byte)27;

	public class Configuration {
		public short averaging;
		public short voltageConversionTime;
		public short currentConversionTime;

		public String toString() {
			return "[" + "averaging = " + averaging + ", " + "voltageConversionTime = " + voltageConversionTime + ", " + "currentConversionTime = " + currentConversionTime + "]";
		}
	}

	public class Calibration {
		public int gainMultiplier;
		public int gainDivisor;

		public String toString() {
			return "[" + "gainMultiplier = " + gainMultiplier + ", " + "gainDivisor = " + gainDivisor + "]";
		}
	}

	public class CurrentCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class VoltageCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class PowerCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setCurrentCallbackPeriod}. The parameter is the current of the
	 * sensor.
	 * 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.CurrentListener} is only triggered if the current has changed since the
	 * last triggering.
	 */
	public interface CurrentListener {
		public void current(int current);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setVoltageCallbackPeriod}. The parameter is the voltage of the
	 * sensor.
	 * 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.VoltageListener} is only triggered if the voltage has changed since the
	 * last triggering.
	 */
	public interface VoltageListener {
		public void voltage(int voltage);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setPowerCallbackPeriod}. The parameter is the power of the
	 * sensor.
	 * 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.PowerListener} is only triggered if the power has changed since the
	 * last triggering.
	 */
	public interface PowerListener {
		public void power(int power);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setCurrentCallbackThreshold} is reached.
	 * The parameter is the current of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link com.tinkerforge.BrickletVoltageCurrent.setDebouncePeriod}.
	 */
	public interface CurrentReachedListener {
		public void currentReached(int current);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setVoltageCallbackThreshold} is reached.
	 * The parameter is the voltage of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link com.tinkerforge.BrickletVoltageCurrent.setDebouncePeriod}.
	 */
	public interface VoltageReachedListener {
		public void voltageReached(int voltage);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setPowerCallbackThreshold} is reached.
	 * The parameter is the power of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link com.tinkerforge.BrickletVoltageCurrent.setDebouncePeriod}.
	 */
	public interface PowerReachedListener {
		public void powerReached(int power);
	}

	/**
	 * Creates an object with the unique device ID \c uid. This object can
	 * then be added to the IP connection.
	 */
	public BrickletVoltageCurrent(String uid) {
		super(uid);

		expectedName = "Voltage/Current Bricklet";

		bindingVersion[0] = 1;
		bindingVersion[1] = 0;
		bindingVersion[2] = 0;

		callbacks[CALLBACK_CURRENT] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int current = (bb.getInt());

				((CurrentListener)listenerObjects[CALLBACK_CURRENT]).current(current);
			}
		};

		callbacks[CALLBACK_VOLTAGE] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int voltage = (bb.getInt());

				((VoltageListener)listenerObjects[CALLBACK_VOLTAGE]).voltage(voltage);
			}
		};

		callbacks[CALLBACK_POWER] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int power = (bb.getInt());

				((PowerListener)listenerObjects[CALLBACK_POWER]).power(power);
			}
		};

		callbacks[CALLBACK_CURRENT_REACHED] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int current = (bb.getInt());

				((CurrentReachedListener)listenerObjects[CALLBACK_CURRENT_REACHED]).currentReached(current);
			}
		};

		callbacks[CALLBACK_VOLTAGE_REACHED] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int voltage = (bb.getInt());

				((VoltageReachedListener)listenerObjects[CALLBACK_VOLTAGE_REACHED]).voltageReached(voltage);
			}
		};

		callbacks[CALLBACK_POWER_REACHED] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int power = (bb.getInt());

				((PowerReachedListener)listenerObjects[CALLBACK_POWER_REACHED]).powerReached(power);
			}
		};
	}

	/**
	 * Returns the current. The value is in mA
	 * and between 0mA and 20000mA.
	 * 
	 * If you want to get the current periodically, it is recommended to use the
	 * listener {@link com.tinkerforge.BrickletVoltageCurrent.CurrentListener} and set the period with 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setCurrentCallbackPeriod}.
	 */
	public int getCurrent() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_CURRENT, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_CURRENT);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int current = (bb.getInt());

		return current;
	}

	/**
	 * Returns the voltage. The value is in mV
	 * and between 0mV and 36000mV.
	 * 
	 * If you want to get the voltage periodically, it is recommended to use the
	 * listener {@link com.tinkerforge.BrickletVoltageCurrent.VoltageListener} and set the period with 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setVoltageCallbackPeriod}.
	 */
	public int getVoltage() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_VOLTAGE, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_VOLTAGE);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = (bb.getInt());

		return voltage;
	}

	/**
	 * Returns the power. The value is in mW
	 * and between 0mV and 720000mW.
	 * 
	 * If you want to get the power periodically, it is recommended to use the
	 * listener {@link com.tinkerforge.BrickletVoltageCurrent.PowerListener} and set the period with 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.setPowerCallbackPeriod}.
	 */
	public int getPower() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_POWER, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_POWER);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int power = (bb.getInt());

		return power;
	}

	/**
	 * Sets the configuration of the Voltage/Current Bricklet. It is
	 * possible to configure number of averages as well as
	 * voltage and current conversion time.
	 * 
	 * Averaging:
	 * 
	 * \verbatim
	 *  "Value", "Number of Averages"
	 * 
	 *  "0",    "1"
	 *  "1",    "4"
	 *  "2",    "16"
	 *  "3",    "64"
	 *  "4",    "128"
	 *  "5",    "256"
	 *  "6",    "512"
	 *  ">=7",  "1024"
	 * \endverbatim
	 * 
	 * Voltage/Current conversion:
	 * 
	 * \verbatim
	 *  "Value", "Conversion time"
	 * 
	 *  "0",    "140µs"
	 *  "1",    "204µs"
	 *  "2",    "332µs"
	 *  "3",    "588µs"
	 *  "4",    "1.1ms"
	 *  "5",    "2.116ms"
	 *  "6",    "4.156ms"
	 *  ">=7",  "8.244ms"
	 * \endverbatim
	 * 
	 * The default values are 3, 4 and 4 (64, 1.1ms, 1.1ms) for averaging, voltage 
	 * conversion and current conversion.
	 */
	public void setConfiguration(short averaging, short voltageConversionTime, short currentConversionTime)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_CONFIGURATION, (short)7);
		bb.put((byte)averaging);
		bb.put((byte)voltageConversionTime);
		bb.put((byte)currentConversionTime);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link com.tinkerforge.BrickletVoltageCurrent.setConfiguration}.
	 */
	public Configuration getConfiguration() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_CONFIGURATION, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_CONFIGURATION);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.averaging = IPConnection.unsignedByte(bb.get());
		obj.voltageConversionTime = IPConnection.unsignedByte(bb.get());
		obj.currentConversionTime = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Since the shunt resistor that is used to measure the current is not
	 * perfectly precise, it needs to be calibrated by a multiplier and
	 * divisor if a very precise reading is needed.
	 * 
	 * For example, if you are expecting a measurement of 1000mA and you
	 * are measuring 1023mA, you can calibrate the Voltage/Current Bricklet 
	 * by setting the multiplier to 1000 and the divisior to 1023.
	 */
	public void setCalibration(int gainMultiplier, int gainDivisor)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_CALIBRATION, (short)8);
		bb.putShort((short)gainMultiplier);
		bb.putShort((short)gainDivisor);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the calibration as set by {@link com.tinkerforge.BrickletVoltageCurrent.setCalibration}.
	 */
	public Calibration getCalibration() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_CALIBRATION, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_CALIBRATION);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Calibration obj = new Calibration();
		obj.gainMultiplier = IPConnection.unsignedShort(bb.getShort());
		obj.gainDivisor = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the period in ms with which the {@link com.tinkerforge.BrickletVoltageCurrent.CurrentListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.CurrentListener} is only triggered if the current has changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setCurrentCallbackPeriod(long period)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_CURRENT_CALLBACK_PERIOD, (short)8);
		bb.putInt((int)period);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the period as set by {@link com.tinkerforge.BrickletVoltageCurrent.setCurrentCallbackPeriod}.
	 */
	public long getCurrentCallbackPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_CURRENT_CALLBACK_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_CURRENT_CALLBACK_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link com.tinkerforge.BrickletVoltageCurrent.VoltageListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.VoltageListener} is only triggered if the voltage has changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setVoltageCallbackPeriod(long period)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, (short)8);
		bb.putInt((int)period);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the period as set by {@link com.tinkerforge.BrickletVoltageCurrent.setVoltageCallbackPeriod}.
	 */
	public long getVoltageCallbackPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link com.tinkerforge.BrickletVoltageCurrent.PowerListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * {@link com.tinkerforge.BrickletVoltageCurrent.PowerListener} is only triggered if the power has changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setPowerCallbackPeriod(long period)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_POWER_CALLBACK_PERIOD, (short)8);
		bb.putInt((int)period);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the period as set by {@link com.tinkerforge.BrickletVoltageCurrent.getPowerCallbackPeriod}.
	 */
	public long getPowerCallbackPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_POWER_CALLBACK_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_POWER_CALLBACK_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link com.tinkerforge.BrickletVoltageCurrent.CurrentReachedListener} listener. 
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the current is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the current is *inside* the min and max values"
	 *  "'<'",    "Listener is triggered when the current is smaller than the min value (max is ignored)"
	 *  "'>'",    "Listener is triggered when the current is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * The default value is ('x', 0, 0).
	 */
	public void setCurrentCallbackThreshold(char option, int min, int max)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD, (short)13);
		bb.put((byte)option);
		bb.putInt((int)min);
		bb.putInt((int)max);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link com.tinkerforge.BrickletVoltageCurrent.setCurrentCallbackThreshold}.
	 */
	public CurrentCallbackThreshold getCurrentCallbackThreshold() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		CurrentCallbackThreshold obj = new CurrentCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the thresholds for the {@link com.tinkerforge.BrickletVoltageCurrent.VoltageReachedListener} listener. 
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the voltage is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the voltage is *inside* the min and max values"
	 *  "'<'",    "Listener is triggered when the voltage is smaller than the min value (max is ignored)"
	 *  "'>'",    "Listener is triggered when the voltage is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * The default value is ('x', 0, 0).
	 */
	public void setVoltageCallbackThreshold(char option, int min, int max)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, (short)13);
		bb.put((byte)option);
		bb.putInt((int)min);
		bb.putInt((int)max);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link com.tinkerforge.BrickletVoltageCurrent.setVoltageCallbackThreshold}.
	 */
	public VoltageCallbackThreshold getVoltageCallbackThreshold() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		VoltageCallbackThreshold obj = new VoltageCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the thresholds for the {@link com.tinkerforge.BrickletVoltageCurrent.PowerReachedListener} listener. 
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the power is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the power is *inside* the min and max values"
	 *  "'<'",    "Listener is triggered when the power is smaller than the min value (max is ignored)"
	 *  "'>'",    "Listener is triggered when the power is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * The default value is ('x', 0, 0).
	 */
	public void setPowerCallbackThreshold(char option, int min, int max)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_POWER_CALLBACK_THRESHOLD, (short)13);
		bb.put((byte)option);
		bb.putInt((int)min);
		bb.putInt((int)max);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link com.tinkerforge.BrickletVoltageCurrent.setPowerCallbackThreshold}.
	 */
	public PowerCallbackThreshold getPowerCallbackThreshold() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_POWER_CALLBACK_THRESHOLD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_POWER_CALLBACK_THRESHOLD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PowerCallbackThreshold obj = new PowerCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the period in ms with which the threshold listeners
	 * 
	 *  {@link com.tinkerforge.BrickletVoltageCurrent.CurrentReachedListener}, {@link com.tinkerforge.BrickletVoltageCurrent.VoltageReachedListener}, {@link com.tinkerforge.BrickletVoltageCurrent.PowerReachedListener}
	 * 
	 * are triggered, if the thresholds
	 * 
	 *  {@link com.tinkerforge.BrickletVoltageCurrent.setCurrentCallbackThreshold}, {@link com.tinkerforge.BrickletVoltageCurrent.setVoltageCallbackThreshold}, {@link com.tinkerforge.BrickletVoltageCurrent.setPowerCallbackThreshold}
	 * 
	 * keep being reached.
	 * 
	 * The default value is 100.
	 */
	public void setDebouncePeriod(long debounce)  {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_SET_DEBOUNCE_PERIOD, (short)8);
		bb.putInt((int)debounce);

		sendRequestNoResponse(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link com.tinkerforge.BrickletVoltageCurrent.setDebouncePeriod}.
	 */
	public long getDebouncePeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = IPConnection.createRequestBuffer((byte)stackID, FUNCTION_GET_DEBOUNCE_PERIOD, (short)4);

		byte[] response = sendRequestExpectResponse(bb.array(), FUNCTION_GET_DEBOUNCE_PERIOD);

		bb = ByteBuffer.wrap(response, 4, response.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Registers a listener object.
	 */
	public void addListener(Object o) {
		if(o instanceof CurrentListener) {
			listenerObjects[CALLBACK_CURRENT] = o;
		} else if(o instanceof VoltageListener) {
			listenerObjects[CALLBACK_VOLTAGE] = o;
		} else if(o instanceof PowerListener) {
			listenerObjects[CALLBACK_POWER] = o;
		} else if(o instanceof CurrentReachedListener) {
			listenerObjects[CALLBACK_CURRENT_REACHED] = o;
		} else if(o instanceof VoltageReachedListener) {
			listenerObjects[CALLBACK_VOLTAGE_REACHED] = o;
		} else if(o instanceof PowerReachedListener) {
			listenerObjects[CALLBACK_POWER_REACHED] = o;
		}
	}
}